/* main procedure */

DEFINE NEW SHARED VARIABLE cnt AS INTEGER INIT 0 NO-UNDO.
DEFINE NEW SHARED BUFFER x-book FOR book.
DEFINE NEW SHARED STREAM log.

/* this function outputs (and counts) the lines to a single frame so they can be easily view
   in the order they were generated */
FUNCTION d RETURNS LOGICAL(INPUT s AS CHARACTER, INPUT p1 AS CHARACTER, INPUT p2 AS CHARACTER):
   cnt = cnt + 1.
   DISPLAY
      cnt FORMAT ">9"
      s   FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.

   DISPLAY STREAM log
      cnt FORMAT ">9"
      s   FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.
END FUNCTION.

OUTPUT STREAM log TO VALUE("1661.log").
d("testing shared buffers", "", "").

ON WRITE OF book OLD bold DO:
   d("     Write of", book.isbn, bold.isbn).
END.

ON FIND OF book DO:
   d("     Find of", book.isbn, "").
END.

ON ASSIGN OF book.isbn OLD VALUE old-val DO:
   d("     Assign of", book.isbn, old-val).
END.

FIND FIRST x-book WHERE x-book.book-id EQ 69896.
d("main0", x-book.isbn, "").

x-book.isbn = "main".

RUN "write_delay/p1.t".
d("main1", x-book.isbn, "").

pause message "time to kill the client!".

/****** FIND FIRST book WHERE book-id EQ 69896. gets converted bad! *****/
FIND FIRST book WHERE book.book-id EQ 69896.
   book.isbn = "0book0".

/* VALIDATE x-book.*/
/* QUIT. */

RUN "write_delay/p2.t".
d("main2", x-book.isbn, "").

RUN "write_delay/p3.t".
d("main3", IF AVAILABLE(x-book) THEN x-book.isbn ELSE "n/a", "").

FIND FIRST x-book WHERE book-id EQ 69896.
x-book.isbn = "0000".


OUTPUT STREAM log CLOSE.
/* end of main procedure. */

