/*
    External procedure with structure:
        - transaction block
            - non-transaction
            - sub-transaction
    The procedure last block is undone.
*/


DEFINE shared VARIABLE cnt AS INTEGER INIT 0 NO-UNDO. /* call counter */
FUNCTION x RETURNS INTEGER () :
   cnt = cnt + 1.
   RETURN cnt.
END FUNCTION.

FUNCTION d RETURNS LOGICAL (INPUT txt AS CHAR) :
   DISPLAY x() FORMAT ">>9" 
           txt FORMAT "x(50)"
       WITH FRAME df NO-LABELS NO-BOX. 
   RETURN YES.
END FUNCTION.

DEFINE shared buffer boo_1 for book.
DEFINE shared buffer boo_2 for book.

d("about to start external block 2").
DO TRANSACTION:
   d("  looking for book *102 in book_2").
   FIND FIRST boo_1 WHERE boo_1.book-id EQ 102.

   d("  about to start transaction block 2.1").
   DO:
      d("    batch assigning new values to book_1").
      ASSIGN boo_1.isbn = "c102"
             boo_1.publisher = "me".
      d("    assiged").

      d("    looking for book *102 in book_2").
      FIND FIRST boo_2 WHERE boo_2.book-id EQ 102.

      d("    validating book_2").
      VALIDATE boo_2.
      d("    validated").
   END.
   d("  transaction block 2.1 ended").

   d("  about to start block 2.2").
   DO TRANSACTION:
      d("  looking for book *101 in book_1").
      FIND FIRST boo_1 WHERE boo_1.book-id EQ 101.
      
      d("    batch assigning new values to book_1").
      ASSIGN boo_1.isbn = "a101"
             boo_1.publisher = "me".
      d("    assiged").
      
      d("    looking for book *101 in book_2").
      FIND FIRST boo_2 WHERE boo_2.book-id EQ 101.

      d("    validating book_2").
      VALIDATE boo_2.
      d("    validated").

      d("    undoing and leaving block 2.2").
      UNDO, LEAVE.

      d("    this does not get executed").
   END.
   d("  block 2.2 ended").
   
END.
d("external block 2 ended").
