DEFINE new shared VARIABLE cnt AS INTEGER INIT 0 NO-UNDO. /* call counter */
FUNCTION x RETURNS INTEGER () :
   cnt = cnt + 1.
   RETURN cnt.
END FUNCTION.

FUNCTION d RETURNS LOGICAL (INPUT txt AS CHAR) :
   DISPLAY x() FORMAT ">>9" 
           txt FORMAT "x(50)"
       WITH FRAME df NO-LABELS NO-BOX. 
   RETURN YES.
END FUNCTION.

ON find of book            d("* FIND " + book.isbn).
ON create of book          d("* CREATE " + book.isbn).
ON ASSIGN of book.isbn     d("* ASSIGN isbn " + book.isbn).
ON ASSIGN of book.book-id  d("* ASSIGN id " + string(book.book-id)).
ON DELETE OF book          d("* DELETE " + book.isbn).
ON WRITE  OF book          d("* WRITE  " + book.isbn).


DEFINE BUFFER boo_1 FOR Book.
define buffer bbb for book.

do transaction:
    find first bbb where bbb.book-id eq 103.
    bbb.isbn = "t103".

    find FIRST bbb where bbb.book-id eq 102.
    undo, leave.
end.

display "ok".
QUIT.


FUNCTION FIND-book RETURNS LOGICAL(INPUT pid AS INTEGER):
   d("FIND-book looking for " + STRING(pid)).
   FIND FIRST boo_1 WHERE book-id EQ pid NO-ERROR.

   IF AVAILABLE boo_1 THEN 
      DO:
         d("found book, altering isbn").
         boo_1.isbn = "f" + STRING(pid).
         DO TRANSACTION:
            d("altering isbn again").
            boo_1.isbn = "x" + STRING(pid).
            d("undoing the last change").
            UNDO, LEAVE.
         END.
         d("returning successfully").
         RETURN YES.
      END.
   ELSE
      DO TRANSACTION:
         d("NOT found. Creating...").
         CREATE boo_1.
         d("configuring").
         ASSIGN boo_1.book-id = pid
                boo_1.isbn = "b" + STRING(pid).
         d("Returning No").
         RETURN NO.
      END.
END FUNCTION.

d("entering transaction").
DO TRANSACTION:
   d("inside outer transaction").
   Find-book(101).
   Find-book(104).

   /* d("validating"). */
   /* VALIDATE boo_1. */

   d("creating duplicate, automatic validation/flush").
   CREATE Boo_1.
   ASSIGN 
      boo_1.book-id = 105
      boo_1.isbn = "b104".

   d("rollbacking").
   UNDO, LEAVE.
END.

d("last test").



/*
  1 entering transaction
  2 inside outer transaction
  3 FIND-book looking for 101
  4 * FIND 101
  5 found book, altering isbn
  6 * ASSIGN isbn f101
  7 altering isbn again
  8 * ASSIGN isbn x101
  9 undoing the last change
 10 returning successfully
 11 FIND-book looking for 104
 12 * WRITE  f101
 13 NOT found. Creating...
 14 * CREATE
 15 configuring
 16 * ASSIGN id 104
 17 * ASSIGN isbn b104
 18 Returning No
 19 creating duplicate, automatic validation/flush
 20 * WRITE  b104
 21 * CREATE
 22 last test

** boo_1 already exists with ISBN "b104". (132)
*/
