DEFINE NEW SHARED VARIABLE cnt AS INTEGER INIT 0 NO-UNDO.
DEFINE NEW SHARED STREAM log.

/* this function outputs (and counts) the lines to a single frame so they can be easily view
   in the order they were generated */
FUNCTION d RETURNS LOGICAL(INPUT s AS CHARACTER, INPUT p1 AS CHARACTER, INPUT p2 AS CHARACTER):
   cnt = cnt + 1.
   DISPLAY
      cnt FORMAT ">9"
      s   FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.

   DISPLAY STREAM log
      cnt FORMAT ">9"
      s   FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS NO-ERROR. /* swallow closed log STREAM error */
END FUNCTION.

OUTPUT STREAM log TO VALUE("2222.log").

ON WRITE OF book OLD biik DO:
   d("    WRITE OF", BUFFER book:NAME, "").
   d("        new:", STRING(BUFFER book:UNIQUE-ID), book.isbn).
   d("        old:", STRING(BUFFER biik:UNIQUE-ID), biik.isbn).
END.

ON ASSIGN OF book.isbn OLD biik DO:
   d("    ASSIGN OF", BUFFER book:NAME, "").
   d("         new:", STRING(BUFFER book:UNIQUE-ID), book.isbn).
   d("         old:", "", biik).
END.

DEFINE BUFFER x-book FOR book.
DEFINE BUFFER   book FOR book.


FIND FIRST book WHERE book.book-id = 69896.
book.isbn = "alba".                    /* Trigger ASSIGN trigger @ line 1 (alba/0000) */

FIND FIRST x-book WHERE x-book.book-id = 69896.
d("before f call", x-book.isbn, "").   /* @ line 4:  Should print 'alba' */

FUNCTION setX RETURN LOGICAL() :
   d("validating x-book 1", "", "").
   VALIDATE x-book.                    /* Trigger WRITE trigger @ line 6 (alba/0000) */
   d("validating book 2", "", "").
   VALIDATE book.                      /* No effect, record already validated by x-book buffer */

   FOR EACH x-book:
      IF x-book.book-id = 69896 THEN DO:
         x-book.isbn = "neagra".       /* Trigger ASSIGN trigger @ line 9 (neagra/alba)*/
         d("inside f set xbook=", x-book.isbn, "").
         VALIDATE x-book.              /* Trigger WRITE trigger @ line 13 (neagra/alba)*/
      END.
   END.

   UNDO.                               /* no output, but record 69896 set to alba, UNSAVED! */
END.

setX().
/* pause message "press SPACE to validate".*/
d("validating book 3", "", "").
VALIDATE book.                          /* Trigger WRITE trigger @ line 17 (alba/0000)*/

book.isbn = "0000".                     /* Trigger ASSIGN trigger @ line 20 (0000/alba) */

d("last line of procedure", "", "").
d("        book:",  STRING(BUFFER book:UNIQUE-ID),   book.isbn).        /* 0000 */
d("      x-book:",  STRING(BUFFER x-book:UNIQUE-ID), x-book.isbn).      /* 0000 */

OUTPUT STREAM log CLOSE.               /* 2 X ** Attempt to write to closed stream log. (1387) */

/* Trigger WRITE trigger @ lines 26-28 (0000/alba) will be printed only in console because
   stream is closed */

/* ----------------------------------------------
 1     ASSIGN OF        book
 2          new:        11       alba
 3          old:                 0000
 4 before f call        alba
 5 validating book 1
 6     WRITE OF         x-book
 7         new:         12       alba
 8         old:         13       0000
 9     ASSIGN OF        x-book
10          new:        12       neagra
11          old:                 alba
12 inside f set xbook=  neagra
13     WRITE OF         x-book
14         new:         12       neagra
15         old:         14       alba
16 validating book 2
17     WRITE OF         book
18         new:         11       alba
19         old:         15       0000
20     ASSIGN OF        book
21          new:        11       0000
22          old:                 alba
23 last line of procedu
24         book:        11       0000
25       x-book:        12       0000
26     WRITE OF         book
27         new:         11       0000
28         old:         16       alba

** Attempt to write to closed stream log. (1387)
** Attempt to write to closed stream log. (1387)
------------------------------------------------ */
