/* call counter */
define var i as integer no-undo init 0.
function x return char () :
    i = i + 1.
    return string(i).
end function.


on find   of book display x() "Session trigger FIND for" book.isbn with no-label no-box.
on write  of book old bold display x() "Session trigger WRITE for" book.isbn "old" bold.isbn with no-label no-box.
on create of book display x() "Session trigger CREATE for" book.isbn with no-label no-box.
on delete of book display x() "Session trigger DELETE for" book.isbn with no-label no-box.
on assign of book.isbn old bisbn display x() "Session trigger ASSIGN for" book.isbn "old" bisbn with no-label no-box.

procedure ppp1 :
    display x() "    Inside procedure start" with frame f0 with no-box.
    do transaction:
        display x() "        Inner transaction start" with frame f0 with no-box.
        create book.

        validate book.  /* does nothing because book disable unchanged */

        display x() "        Inner transaction end" with frame f0 with no-box.
    end.
    book.publisher = "me".

    validate book.   /* will fire WRITE event because book has been changed */
    display x() "    Inside procedure end" with frame f0 with no-box.
end.

do /*transaction*/:
    display x() "  Outer transaction start" with frame f0 with no-box.
    run ppp1.

    display x() "  Outer transaction continue" with frame f0 with no-box.
    book.isbn = "111".
    book.book-id = 111.


    display x() "Before release" with frame f0 with no-box.
    release book.

    display x() "Before outer create" with frame f0 with no-box.
    create book.
    book.isbn = "222".
    book.book-id = 222.
    display x() "  Outer transaction end" with frame f0 with no-box.
end.

display x() "Top scope continue " with frame f0 with no-box.
validate book.   /* will fire WRITE event because book has been changed */

display x() "Before cleanup" with frame f0 with no-box.

find first book where isbn = "222".
delete book.

find first book where isbn = "111".
delete book.

display x() "Top scope end" with frame f0 with no-box.


/* Expected output:
1          Outer transaction start
2            Inside procedure start
3                Inner transaction start
4        Session trigger CREATE for
5                Inner transaction end
6        Session trigger WRITE for                 old
7            Inside procedure end
8          Outer transaction continue
9        Session trigger ASSIGN for 111             old
10       Session trigger WRITE for 111             old
11       Session trigger CREATE for
12       Session trigger ASSIGN for 222             old
13         Outer transaction end
14       Top scope continue
15       Session trigger WRITE for 222             old
16       Before cleanup
17       Session trigger FIND for 222
18       Session trigger DELETE for 222
19       Session trigger FIND for 111
20       Session trigger DELETE for 111
21       Top scope end
*/
