DEFINE VARIABLE cnt AS INTEGER INIT 0 NO-UNDO. /* call counter */
FUNCTION x RETURNS INTEGER () :
   cnt = cnt + 1.
   RETURN cnt.
END FUNCTION.

FUNCTION d RETURNS LOGICAL (INPUT txt AS CHAR) :
   DISPLAY x() FORMAT ">>9"
           txt FORMAT "x(50)" 
      WITH FRAME df NO-LABELS NO-BOX.

   RETURN YES.
END FUNCTION.

ON find of book            d("* FIND " + book.isbn).
ON create of book          d("* CREATE " + book.isbn).
ON ASSIGN of book.isbn     d("* ASSIGN isbn " + book.isbn).
ON ASSIGN of book.book-id  d("* ASSIGN id " + string(book.book-id)).
ON DELETE OF book          d("* DELETE " + book.isbn).
ON WRITE  OF book          d("* WRITE  " + book.isbn).

DO TRANSACTION:
   d("cleanup ...").
/*   DISABLE TRIGGERS FOR LOAD OF book.
   DISABLE TRIGGERS FOR DUMP OF book. */

   FIND FIRST book WHERE book-id EQ 104 NO-ERROR.
   IF AVAILABLE book THEN DO:
      DELETE book.
   END.

   FIND FIRST book WHERE book-id EQ 101.
   book.isbn = "101".
   book.publisher = "".
   /* VALIDATE book. */

   FIND FIRST book WHERE book-id EQ 102.
   book.isbn = "102".
   book.publisher = "".
   /* VALIDATE book. */

   RELEASE book.
   d("cleanup done").
END.


DEFINE buffer boo_1 for book.
DEFINE buffer boo_2 for book.

d("about to start external block 1").
DO:
   d("  looking for book *102 in book_1").
   FIND FIRST boo_1 WHERE boo_1.book-id EQ 102.

   d("  about to start transaction block 1.1").
   DO TRANSACTION:
      d("    batch assigning new values to book_1").
      ASSIGN boo_1.isbn = "c102"
             boo_1.publisher = "me".
      d("    assiged").

      d("    looking for book *102 in book_2").
      FIND FIRST boo_2 WHERE boo_2.book-id EQ 102.

      d("    validating book_2").
      VALIDATE boo_2.
      d("    validated").
   END.
   d("  transaction block 1.1 ended").

   d("  about to start block 1.2").
   DO:
      d("  looking for book *101 in book_1").
      FIND FIRST boo_1 WHERE boo_1.book-id EQ 101.
      
      d("    batch assigning new values to book_1").
      ASSIGN boo_1.isbn = "a101"
             boo_1.publisher = "me".
      d("    assiged").
      
      d("    looking for book *101 in book_2").
      FIND FIRST boo_2 WHERE boo_2.book-id EQ 101.

      d("    validating book_2").
      VALIDATE boo_2.
      d("    validated").

      d("    undoing and leaving block 1.2").
      UNDO, LEAVE.

      d("    this does not get executed").
   END.
   d("  block 1.1 ended").
   



END.
d("external block 1.1 ended").


/*
  1 cleanup ...
  2 cleanup done
  3 about to start external block 1
  4   looking for book *102 in book_1
  5   about to start transaction block 1.1
  6     batch assigning new values to book_1
  7     assiged
  8     looking for book *102 in book_2
  9     validating book_2
 10     validated
 11   transaction block 1.1 ended
 12   about to start block 1.2
 13   looking for book *101 in book_1
 14     batch assigning new values to book_1
 15     assiged
 16     looking for book *101 in book_2
 17     validating book_2
 18     validated
 19     undoing and leaving block 1.2
*/
