/* nested blocks tests */
DEFINE VARIABLE cnt AS INTEGER INIT 0 NO-UNDO.

FUNCTION d RETURNS LOGICAL(INPUT s AS CHARACTER, INPUT p1 AS CHARACTER, INPUT p2 AS CHARACTER):
   cnt = cnt + 1.
   DISPLAY
      cnt FORMAT ">9"
      s FORMAT "x(20)"
      p1
      p2
      SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.
END FUNCTION.

/* initial cleanup */
find book where book.book-id = 69896 no-error.
if available(book) THEN DO:
   d("found isbn-book", book.isbn, "").  /* line #1 */
   delete book.
END.

ON WRITE OF book OLD BUFFER obook
    d("Writing book", book.isbn, obook.isbn).

/* creating test record */
CREATE book.
ASSIGN book.isbn = "varza"
       book.book-id = 69896.
DISPLAY "New book assigned" SKIP WITH FRAME f0 WITH NO-BOX NO-LABELS.

/* the FIND will trigger flush/WRITE event #2 */
find first book where book.book-id eq 69896.
IF cnt NE 2 THEN DO:
    MESSAGE "Write trigger failed to execute!".
    cnt = cnt + 1.       /* keep then counter in sync */
END.

ON ASSIGN OF book.isbn OLD VALUE ov DO:
    isbn = "'" + isbn + "'".
    d("Assigning book", isbn, ov).
END.

DO TRANSACTION:
    book.isbn = "cirese".                               /* assign trigger #3 */

    d("About to enter 2nd nested transaction", "", ""). /* line #4 */
    DO TRANSACTION:
        book.isbn = "visine".                           /* assign trigger #5 */
        VALIDATE book.                                  /* triggers Write #6 'visine' */

        UNDO, LEAVE.                                    /* book.isbn is set back 'cirese', old value='varza' UNpersisted */
    END.
    d("Leaving nested transactions", "", "").           /* line #7 */
END.

d("Out of nested transactions", "", "").                /* line #8 */

/* validate book. - will trigger Write #9 anyway at the end of the ext. procedure */


/*
 1 found isbn-book      'cirese'
New book assigned
 2 Writing book         varza
 3 Assigning book       'cirese' varza
 4 About to enter 2nd n
 5 Assigning book       'visine' 'cirese'
 6 Writing book         'visine' varza
 7 Leaving nested trans
 8 Out of nested transa
 9 Writing book         'cirese' varza
*/
